#include "codedblockpattern.hpp"

VLC_Entry CodedBlockPattern::table[] =
{
    {0x7, 60, 3},
    {0xD, 4, 4},
    {0xC, 8, 4},
    {0xB, 16, 4},

    {0xA, 32, 4},
    {0x13, 12, 5},
    {0x12, 48, 5},
    {0x11, 20, 5},

    {0x10, 40, 5},
    {0xF, 28, 5},
    {0xE, 44, 5},
    {0xD, 52, 5},

    //16
    {0xC, 56, 5},
    {0xB, 1, 5},
    {0xA, 61, 5},
    {0x9, 2, 5},

    //20
    {0x8, 62, 5},
    {0xF, 24, 6},
    {0xE, 36, 6},
    {0xD, 3, 6},

    //24
    {0xC, 63, 6},
    {0x17, 5, 7},
    {0x16, 9, 7},
    {0x15, 17, 7},

    //28
    {0x14, 33, 7},
    {0x13, 6, 7},
    {0x12, 10, 7},
    {0x11, 18, 7},

    //32
    {0x10, 34, 7},
    {0x1F, 7, 8},
    {0x1E, 11, 8},
    {0x1D, 19, 8},

    //36
    {0x1C, 35, 8},
    {0x1B, 13, 8},
    {0x1A, 49, 8},
    {0x19, 21, 8},

    //40
    {0x18, 41, 8},
    {0x17, 14, 8},
    {0x16, 50, 8},
    {0x15, 22, 8},

    //44
    {0x14, 42, 8},
    {0x13, 15, 8},
    {0x12, 51, 8},
    {0x11, 23, 8},

    //48
    {0x10, 43, 8},
    {0xF, 25, 8},
    {0xE, 37, 8},
    {0xD, 26, 8},

    //52
    {0xC, 38, 8},
    {0xB, 29, 8},
    {0xA, 45, 8},
    {0x9, 53, 8},

    //56
    {0x8, 57, 8},
    {0x7, 30, 8},
    {0x6, 46, 8},
    {0x5, 54, 8},

    //60
    {0x4, 58, 8},
    {0x7, 31, 9},
    {0x6, 47, 9},
    {0x5, 55, 9},

    //64
    {0x4, 59, 9},
    {0x3, 27, 9},
    {0x2, 39, 9},
    {0x1, 0, 9}
};

unsigned int CodedBlockPattern::index_table[9] =
{
    0,
    0,
    0,
    1,
    5,
    17,
    21,
    29,
    57,
};

CodedBlockPattern::CodedBlockPattern() : VLC_Table(table, SIZE, 9, index_table)
{

}
